package org.kisti.htc.myproxy;

import java.util.Scanner;

//import org.globus.common.CoGProperties;
import org.globus.gsi.GlobusCredential;
import org.globus.tools.ui.proxy.GridProxyProperties;
import org.globus.util.ConfigUtil;
import org.ietf.jgss.GSSCredential;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class HTCaaS_ProxyLogon extends gridPropertiesUtil {
  
	static Scanner in = new Scanner(System.in);
	
//	public MyProxy myproxy; 
//	private final static String TRUSTED_CERT_PATH = "/.globus/certificates";
    private GlobusCredential gridProxy = null;
    private GSSCredential credential = null;
    
    final static Logger logger = LoggerFactory.getLogger(HTCaaS_ProxyLogon.class);
    
    static String username="";
    static String password="";
    static String myproxyPassword="";
 
    
    // Constructor 1
    public HTCaaS_ProxyLogon(String un, String pw, String mpw){
    	super();
    	this.username = un;
    	this.password = pw;
    	this.myproxyPassword = mpw;
    	
    	if(checkProperties()){
    		printProperties();
    	}else {
    		System.out.println("SET THE PROPERTIES !");
    	}
    }

	// Constructor 2    
    public HTCaaS_ProxyLogon(GridProxyProperties gpp, String un, String pw, String mpw){
    	super();
    	this.username = un;
    	this.password = pw;
    	this.myproxyPassword = mpw;
    	this.gridProps = gpp;
    	printProperties();
    }
    
    
    public void Logon(){
    	
    	MyProxyLogon myproxylogon = new MyProxyLogon();    	
        try {
        	
            myproxylogon.setUsername(username.trim());
            myproxylogon.setPassphrase(new String(myproxyPassword));
//            if (crednameField.getText().length() > 0) {
//                myproxylogon.setCredentialName(crednameField.getText());
//            }
//            myproxylogon
//                    .setLifetime(Integer.parseInt(lifetimeField.getText()) * 3600);
            myproxylogon
            .setLifetime(gridProps.getCredLifetime()* 3600);
            myproxylogon.setHost(gridProps.getMyproxyServer());
            myproxylogon.setPort(gridProps.getMyproxyPort());
            //TODO IMPORTANT!!!
            // myproxylogon.requestTrustRoots(trustRootsCheckBox.isSelected());
//            statusTextArea.setText("Connecting to " + myproxylogon.getHost()
//                    + "...\n");
            myproxylogon.connect();
           // statusTextArea.setText("Logging on...\n");
            myproxylogon.logon();
//            if (outputField.getText().length() == 0) {
//                statusTextArea.setText("Logon successful.\n");
//            } else {
//                statusTextArea.setText("Getting credentials...\n");
              myproxylogon.getCredentials();
//                statusTextArea.setText("Writing credentials...\n");
//               myproxylogon.saveCredentialsToFile(outputField.getText());
//                statusTextArea.setText("Credentials written to "
//                        + outputField.getText() + ".\n");
//            }
//            if (trustRootsCheckBox.isSelected() && myproxylogon.writeTrustRoots()) {
//                statusTextArea.append("Trust roots written to "
//                        + myproxylogonLogon.getTrustRootPath() + ".\n");
//            }
//            saveProperties();
        } catch (Exception exception) {
            exception.printStackTrace();
            System.out.println("Error: " + exception.getMessage());
//            statusTextArea.append("Error: " + exception.getMessage());
        } finally {
            try {
                myproxylogon.disconnect();
            } catch (Exception e2) {
            }
        }
    }
	
    // To Check a file for Proxy Properties
    public boolean checkProperties(){ 	 	
    	return gridProps.hasProperties() ;
    }
    
    // To Print Grid Properties
    public void printProperties(){
    	
    	//String PROPS_FILE = CoGProperties.CONFIG_FILE; 	
    	System.out.println("Default location: " + ConfigUtil.globus_dir);
    	System.out.println(gridProps.getHours());
    	System.out.println(gridProps.getBits());
    	System.out.println(gridProps.getLimited());
    	System.out.println(gridProps.getUserCertFile());
    	System.out.println(gridProps.getUserKeyFile());
    	System.out.println(gridProps.getProxyFile());
    	System.out.println(gridProps.getCACertFile());
    	System.out.println(gridProps.getCredLifetime());
    	System.out.println(gridProps.getPortalLifetime());
    	System.out.println(gridProps.getMyproxyServer());
    	System.out.println(gridProps.getMyproxyPort());
    	
    }
    
    public void setUsername(String un){
    		username = un;
    }
    public void setPassword (String pw){
		password = pw;
    }
    public void setMyproxyPassword (String mpw){
		myproxyPassword = mpw;
    }
    
    
	public static void main(String[] args) {
		
		HTCaaS_ProxyLogon aaa = new HTCaaS_ProxyLogon("seoyoung","sy1357","sy1357");
		aaa.gridProps.setMyproxyServer("amga.kisti.re.kr");
		aaa.gridProps.saveProperties();
		aaa.Logon();	

	}
	
	  public void Logon2(){
	    	
	    	MyProxyLogon myproxylogon = new MyProxyLogon();    	
	        try {
	        	
	            myproxylogon.setUsername(username.trim());
	            myproxylogon.setPassphrase(new String(myproxyPassword));

	            myproxylogon
	            .setLifetime(gridProps.getCredLifetime()* 3600);
	            myproxylogon.setHost(gridProps.getMyproxyServer());
	            myproxylogon.setPort(gridProps.getMyproxyPort());
	            //TODO IMPORTANT!!!
	            // myproxylogon.requestTrustRoots(trustRootsCheckBox.isSelected());
//	            statusTextArea.setText("Connecting to " + myproxylogon.getHost()
//	                    + "...\n");
	            myproxylogon.connect();
	           // statusTextArea.setText("Logging on...\n");
	            myproxylogon.logon();
//	            if (outputField.getText().length() == 0) {
//	                statusTextArea.setText("Logon successful.\n");
//	            } else {
//	                statusTextArea.setText("Getting credentials...\n");
	              myproxylogon.getCredentials();
//	                statusTextArea.setText("Writing credentials...\n");
//	               myproxylogon.saveCredentialsToFile(outputField.getText());
//	                statusTextArea.setText("Credentials written to "
//	                        + outputField.getText() + ".\n");
//	            }
//	            if (trustRootsCheckBox.isSelected() && myproxylogon.writeTrustRoots()) {
//	                statusTextArea.append("Trust roots written to "
//	                        + myproxylogonLogon.getTrustRootPath() + ".\n");
//	            }
//	            saveProperties();
	        } catch (Exception exception) {
	            exception.printStackTrace();
	            System.out.println("Error: " + exception.getMessage());
//	            statusTextArea.append("Error: " + exception.getMessage());
	        } finally {
	            try {
	                myproxylogon.disconnect();
	            } catch (Exception e2) {
	            }
	        }
	    }
		
	
	
}
